package freeforums;

import java.io.*;
import java.util.Hashtable;
import java.util.Enumeration;

public class ConfigurationReader extends Object {

 Hashtable IniElements;
 String FileName;
 BufferedReader file_in;

 public void setFileName(String inFileName) {
  FileName=inFileName;
 }

 public String getFileName() { return FileName; }

 public ConfigurationReader(String filename) {
  IniElements=new Hashtable();
  open(filename);
 }

 public void open(String file_name) {
  setFileName(file_name);
  try { file_in=new BufferedReader(new FileReader(FileName)); }
  catch (IOException e) {
   System.err.println("INI File handler - error opening file "+file_name);
   return;
  }

  String input="";

  try {
   input=file_in.readLine();
  }
  catch(IOException e) {
   System.err.println("Error reading from file");
  }

  while(input!=null) {
   if(input.length()==0) {
    try {
     input=file_in.readLine();
    }
    catch(IOException e) {
     System.err.println("Error reading from file");
    }
    continue;
   }
   if (input.indexOf("=")>0 && !(input.substring(0,1).equals("#"))) {
    String name=input.substring(0,input.indexOf("="));
    String value=input.substring(input.indexOf("=")+1, input.length());
    IniElements.put(name,value);
   }
   try {
    input=file_in.readLine();
   }
   catch(IOException e) {
    System.err.println("Error reading from file");
   }
  }
  try {
   file_in.close();
  }
  catch(IOException e) {
   System.err.println("Error closing the file");
  }
 }

 public String getValue(String in_key) {
  return ((String)IniElements.get(in_key));
 }

 public void setValue(String in_key, String in_value) {
  IniElements.put(in_key,in_value);
 } 

 public int elements() { return IniElements.size(); }

 public void write() {
  String value="",name="";
  PrintWriter file_out=null;
  try {
   file_out=new PrintWriter(new BufferedWriter(new FileWriter(FileName)));
  }
  catch(IOException e) {
   // do nothing
  }
  for(Enumeration enum = IniElements.keys() ; enum.hasMoreElements() ;) {
   name=(String)enum.nextElement();
   value=(String)IniElements.get(name);
   file_out.println(name+"="+value);
  }
  file_out.close();
 }
 
} //end class 
