package freeforums;

import java.io.*;
import java.util.Date;
import java.util.Calendar;

public class Message extends Object implements Serializable {

 private int Message_Id, Replyto_Id;
 private String Subject, Message_Text, Username;
 private Date Message_Date;

 public int getMessageId() { return Message_Id; }
 public int getReplytoId() { return Replyto_Id; }
 public String getSubject() { return Subject; }
 public String getMessageText() { return Message_Text; }
 public String getUsername() { return Username; }
 public Date getMessageDate() { return Message_Date; }

 public void setMessageId(int inMessageId) { Message_Id=inMessageId; }
 public void setReplytoId(int inId) { Replyto_Id=inId; }
 public void setSubject(String subject) { Subject=subject; }
 public void setMessageText(String message) { Message_Text=message; }
 public void setUsername(String username) { Username=username; }
 public void setMessageDate(Date message_date) { Message_Date=message_date; }
 
 public Message() {
  Subject=Message_Text=Username="";
  Message_Date=new Date();
 }

 public Message(int Messageid,String inSubject, String inMessageText, String inUsername, int inReplyto, Date inDate) {
  Message_Id=Messageid;
  Subject=inSubject;
  Message_Text=inMessageText;
  Username=inUsername;
  Replyto_Id=inReplyto;
  Message_Date=inDate;
 }

 public String toString() {
  if(Replyto_Id==-1) return "->"+Message_Id+" "+Subject+" ("+Username+") ";
  else return "  "+Message_Id+" "+Subject+" ("+Username+") in reply to "+Replyto_Id;
 }

 // Methods that enable writing to web pages

 public String toHTML(boolean read, int depth) {
  String outString="<tr>\n";
  String date_string=""+Message_Date.getDate()+"/"+Message_Date.getMonth()+"/"+(1900+Message_Date.getYear())+" "+Message_Date.getHours()+":"+Message_Date.getMinutes();
  outString+="<td><p>"+date_string+"</p></td><td>\n";
  outString+="<img src=\"images/spacer.gif\" height=1 width="+depth+">";
  outString+="<a href=\"read_message.jsp?message_id="+Message_Id+"\">";
  if(read) outString+="<font face=\"Verdana\" size=2>"+Subject+"</font>";
  else outString+="<font face=\"Verdana\" size=2><b>"+Subject+"</b></font>";
  outString+="</a></td>\n";
  outString+="<td><p>"+Username+"</p></td>\n";
  outString+="<td><p>[<a href=\"post_message.jsp?replyto="+Message_Id+"\">reply</a>]</p></td>\n";
  outString+="</tr>";
  return outString;
 }
}
