package freeforums;

import java.io.*;
import java.util.Date;

public class MessageManager extends Object
{
   static MessageCollection messages;
   static BufferedReader console;
   static String configFile;

   static int menu_option () throws IOException
   {
      int option;
      do
      {  System.out.println ("\nFreeForums Console Management Utility v1");
         System.out.println ("Message Manager Menu");
         System.out.print ("File: ");
         if (messages.getFilename() == null)
            System.out.println();
         else
            System.out.println (messages.getFilename());
         System.out.println ("---------------------");
         System.out.println ("1. Add a Message");
         System.out.println ("2. Delete a Message");
         System.out.println ("3. List all Messages");
         System.out.println ("4. List as HTML");
         System.out.println ("5. New file");
         System.out.println ("6. Open file");
         System.out.println ("7. Save file");
         System.out.println ("8. Save file as...");
         System.out.println ("9. Quit");
         option = Integer.parseInt(console.readLine());
      } while ((option < 1) || (option > 9));
      return option;
   }

   static void add_message() throws IOException
   {
      System.out.print ("Enter Subject : ");
      String subject=console.readLine();
      System.out.print ("Enter Message : ");
      String message=console.readLine();
      System.out.print ("Enter username : ");
      String username=console.readLine();
      System.out.print ("In reply to : ");
      String replyid=console.readLine();
      int replyto=-1;
      if (!replyid.equals("")) replyto=Integer.parseInt(replyid);
      messages.putMessage(subject,message,username,replyto,new Date());
   }
   static void delete() throws IOException
   {
      System.out.print ("Enter message Id: ");
      if (!messages.deleteMessage (Integer.parseInt(console.readLine())))
         System.out.println ("That message doesn't seem to exist");
   }

   static void list() throws IOException
   {
      System.out.println (messages.listAll());
      System.out.print("Press enter to continue");
      console.readLine();
      System.out.println ("\n\n" + messages);
   }

   static void listHTML() throws IOException {
    System.out.print("Enter usename: ");
    String username=console.readLine();
    System.out.println("Where is the read messages data file? ");
    String readfile=console.readLine();
    System.out.println(messages.toHTML(readfile,username));
   }

   static void new_file() throws IOException, ClassNotFoundException
   {
      messages.newFile();
   }

   static void open() throws IOException, ClassNotFoundException
   {
      System.out.print ("Enter filename: ");
      messages.open (console.readLine());
   }

   static void save() throws IOException
   {
      if (messages.getFilename() == null)
         save_as();
      else
         messages.save();
   }

   static void save_as() throws IOException
   {
      System.out.print ("Enter filename: ");
      messages.saveAs (console.readLine());
   }

   public static void main (String[] args) throws IOException, ClassNotFoundException
   {
      int option;
      console = new BufferedReader (new InputStreamReader (System.in));
      System.out.println("Where is freeforums.conf? ");
      configFile=console.readLine();
      messages = new MessageCollection(configFile);
      do
      {
         option=menu_option ();
         switch (option)
         {
            case 1: add_message(); break;
            case 2: delete(); break;
            case 3: list(); break;
            case 4: listHTML(); break;
            case 5: new_file(); break;
            case 6: open(); break;
            case 7: save(); break;
            case 8: save_as(); break;
            case 9: break;
         }
      } while (option != 9);
   }
}


