package freeforums;

import java.io.*;
import java.util.*;

public class ReadMessageCollection extends Object implements Serializable {

 protected Vector ReadMessages;
 protected String filename;
   
 public ReadMessageCollection() {
  filename=null;
  ReadMessages = new Vector();
 }

 public ReadMessageCollection(String in_filename) throws IOException {
  open(in_filename);
 }

 public void open(String file_name) {
  filename=file_name;
  FileHandler file=null;
  try {
   file=new FileHandler(filename,true);
  }
  catch(IOException e) {
   System.err.println("Error opening file");
  }
  catch(ClassNotFoundException e) {
   System.err.println("Class Not found in package");
  }
  ReadMessages=file.getData();
 }

 public void newFile() throws IOException, ClassNotFoundException {
  filename=null;
  ReadMessages = new Vector();
 }

 public String getFilename() { return filename; }

 public int getNumReadMessages() { return ReadMessages.size(); }

 public Message getMessageByIndex (int index) {
  return (Message) ReadMessages.elementAt(index);
 }

 public void putMessage (String username, int MessageId) {
  ReadMessages.addElement (new ReadMessage(username, MessageId));
 }

 public boolean isRead(String username, int MessageId) {
  ReadMessage currentMessage;
  for (int i=0; i<ReadMessages.size(); ++i) {
   currentMessage=(ReadMessage)ReadMessages.elementAt(i);
   if (currentMessage.getUsername().equals(username) && currentMessage.getMessageId()==MessageId)
    return true;
  }
  return false;   
 }
 
 public void save() {
  FileHandler file=new FileHandler();
  try {
   file.write(ReadMessages,filename);
  }
  catch(IOException e) {
   System.err.println("Error opening file");
  }
  catch(ClassNotFoundException e) {
   System.err.println("Class Not found in package");
  }
 }

 public void saveAs (String new_filename) {
  filename = new_filename;
  save();
 }

}
