package freeforums;

import java.io.*;
import java.util.*;

public class UserCollection extends Object implements Serializable {

 protected Vector users;
 protected String filename;
   
 public UserCollection() {
  filename=null;
  users = new Vector();
 }

 public UserCollection(String in_filename) throws IOException, ClassNotFoundException {
  open(in_filename);
 }

 public void open(String file_name) {
  filename=file_name;
  FileHandler file=null;
  try {
   file=new FileHandler(filename,true);
  }
  catch(IOException e) {
   System.err.println("Error opening file");
  }
  catch(ClassNotFoundException e) {
   System.err.println("Class Not found in package");
  }
  users=file.getData();
 }

 public void newFile() throws IOException, ClassNotFoundException {
  filename=null;
  users = new Vector();
 }

 public String getFilename() { return filename; }

 public int getNumUsers() { return users.size(); }

 public User getUser (String in_username) {
  for (int i=0; i<users.size(); ++i)
   if (((User)users.elementAt(i)).getUserName().equals(in_username))
    return (User) users.elementAt(i);
  return null;
 }

 public User getUserByIndex (int index) {
  return (User) users.elementAt(index);
 }

 public boolean putUser (User user) {
  for (int i=0; i<users.size(); ++i)
   if (((User)users.elementAt(i)).getUserName().equals(user.getUserName()))
    return false;
   else if (((User)users.elementAt(i)).getUserName().compareTo(user.getUserName()) > 0) {
    users.insertElementAt(user,i);
    return true;
   }
   users.addElement (user);
   return true;
 }

 public boolean deleteUser (String in_username) {
  for (int i=0; i<users.size(); ++i)
   if (((User)users.elementAt(i)).getUserName().equals(in_username)) {
    users.removeElementAt(i);
    return true;
   }
  return false;
 }

 public void save() {
  FileHandler file=new FileHandler();
  try {
   file.write(users,filename);
  }
  catch(IOException e) {
   System.err.println("Error opening file");
  }
  catch(ClassNotFoundException e) {
   System.err.println("Class Not found in package");
  }
 }

 public void saveAs (String new_filename) {
  filename = new_filename;
  save();
 }

 public String toString() {
  String the_string="";
  for (int i=0; i<users.size(); ++i)
   the_string+=users.elementAt(i)+"\n";
  return the_string;
 }

}


