package freeforums;

import java.io.*;

public class UserManager extends Object
{
   static UserCollection users;
   static BufferedReader console;

   static int menu_option () throws IOException
   {
      int option;
      do
      {  System.out.println ("\nFreeForums Console Management Utility v1");
         System.out.println ("User Manager Menu");
         System.out.print ("File: ");
         if (users.getFilename() == null)
            System.out.println();
         else
            System.out.println (users.getFilename());
         System.out.println ("---------------------");
         System.out.println ("1. Add a User");
         System.out.println ("2. Delete a user");
         System.out.println ("3. List all users");
         System.out.println ("4. New file");
         System.out.println ("5. Open file");
         System.out.println ("6. Save file");
         System.out.println ("7. Save file as...");
         System.out.println ("8. Quit");
         option = Integer.parseInt(console.readLine());
      } while ((option < 1) || (option > 9));
      return option;
   }

   static void add_user() throws IOException
   {
      System.out.print ("Enter username: ");
      String new_usercode = console.readLine();
      if (users.getUser (new_usercode) != null)
      {
         System.out.println ("A user with that usercode already exists");
         return;
      }
      User user = new User(new_usercode);
      System.out.print ("Enter Real name: ");
      user.setRealName (console.readLine());
      System.out.print ("Enter password: ");
      user.setPassword (console.readLine());
      System.out.print ("Enter email address: ");
      user.setEmail (console.readLine());
      System.out.print ("Is this a superuser [yes/no]");
      user.setSuperUser(console.readLine().equalsIgnoreCase("yes"));
      if (users.putUser (user))
         System.out.println ("User added successfully");
      else
         System.out.println ("User was not able to be added");
   }

   static void delete() throws IOException
   {
      System.out.print ("Enter usercode: ");
      if (!users.deleteUser (console.readLine()))
         System.out.println ("That user doesn't seem to exist");
   }

   static void list() throws IOException
   {
      System.out.println ("\n\n" + users);
   }

   static void new_file() throws IOException, ClassNotFoundException
   {
      users.newFile();
   }

   static void open() throws IOException, ClassNotFoundException
   {
      System.out.print ("Enter filename: ");
      users.open (console.readLine());
   }

   static void save() throws IOException
   {
      if (users.getFilename() == null)
         save_as();
      else
         users.save();
   }

   static void save_as() throws IOException
   {
      System.out.print ("Enter filename: ");
      users.saveAs (console.readLine());
   }

   public static void main (String[] args) throws IOException, ClassNotFoundException
   {
      int option;
      console = new BufferedReader (new InputStreamReader (System.in));
      users = new UserCollection();
      do
      {
         option=menu_option ();
         switch (option)
         {
            case 1: add_user(); break;
            case 2: delete(); break;
            case 3: list(); break;
            case 4: new_file(); break;
            case 5: open(); break;
            case 6: save(); break;
            case 7: save_as(); break;
            case 8: break;
         }
      } while (option != 8);
   }
}


